/*
 * Copyright (c) 2006 Computer-Aided Integrated Systems Laboratory, 
 * St. Petersburg Institute for Informatics and Automation RAS http://cais.lisa.iias.spb.su
 *
 * This software is open-source under the BSD license; see either "license.txt" 
 * or http://jung.sourceforge.net/license.txt for a description.
 */

package edu.uci.ics.jung.io;

import matching.GraphCreator;
import matching.UnicodeVertexStringer;

import junit.framework.*;
import java.awt.geom.Point2D;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import edu.uci.ics.jung.graph.DirectedEdge;
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.UndirectedEdge;
import edu.uci.ics.jung.graph.Vertex;
import edu.uci.ics.jung.graph.decorators.ConstantEdgeValue;
import edu.uci.ics.jung.graph.decorators.Indexer;
import edu.uci.ics.jung.graph.decorators.NumberEdgeValue;
import edu.uci.ics.jung.graph.decorators.VertexStringer;
import edu.uci.ics.jung.utils.Pair;
import edu.uci.ics.jung.utils.PredicateUtils;
import edu.uci.ics.jung.visualization.VertexLocationFunction;

public class PajekNetWriterTest extends TestCase {
    
    public PajekNetWriterTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
    }

    protected void tearDown() throws Exception {
    }

    public static Test suite() {
        TestSuite suite = new TestSuite(PajekNetWriterTest.class);
        
        return suite;
    }

    /**
     * Test of save method, of class edu.uci.ics.jung.io.PajekNetWriter.
     */
    public void testSave() throws Exception {
        System.out.println("save");
        /*
        String result_should_be = 
            "*Vertices 4\n" +
            "1 \"Thing\"\n" +
            "2 \"Provider\"\n" +
            "3 \"Furniture\"\n" +
            "4 \"Computer\"\n" +
            "*Edges\n" +
            "1 2 1.0\n" +
            "2 3 1.0\n" +
            "3 4 1.0\n" +
            "2 4 1.0\n";
         */
        String result_should_be = 
            "*Vertices 4\n" +
            "1 \"Furniture\"\n" +
            "2 \"Provider\"\n" +
            "3 \"Computer\"\n" +
            "4 \"Thing\"\n" +
            "*Edges\n" +        // { {1,2}, {2,3}, {2,4}, {3,4}};
            "3 1 1.0\n" +
            "2 3 1.0\n" +
            "2 1 1.0\n" +
            "4 2 1.0";
        
        GraphCreator creator = new GraphCreator();
        Graph g = creator.createGraph(creator.labels2, creator.edges2);
        
        VertexStringer vs = new UnicodeVertexStringer();
        NumberEdgeValue nev = null;
        VertexLocationFunction vld = null;
        PajekNetWriter writer = new PajekNetWriter();
        
        String s = writer.saveToString(g, vs, nev, vld);
        System.out.println(s);
        
        //assertEquals(s.equalsIgnoreCase(result_should_be));
        assertEquals(s, result_should_be);
    }
    
}
